CREATE DEFAULT DF__Orders__OrderDat__0EC32C7A
 AS getdate()
go

CREATE DEFAULT DefFlag
 AS 0
go

CREATE DEFAULT DefID
 AS 1
go

CREATE DEFAULT DefInterMark
 AS 2
go

CREATE DEFAULT DefLOwner
 AS 1
go

CREATE DEFAULT DefNoname
 AS '()'
go

CREATE DEFAULT DefUser
 AS 1
go

exec sp_addtype Flag, "binary(1)", "NULL"
exec sp_bindefault DefFlag, Flag
go

exec sp_addtype ExtDataPrompt, "binary(1)", "NULL"
exec sp_bindefault DefFlag, ExtDataPrompt
go

exec sp_addtype External, "binary(1)", "NULL"
exec sp_bindefault DefFlag, External
go

exec sp_addtype LastOwner, "bit", "NOT NULL"
exec sp_bindefault DefFlag, LastOwner
go

exec sp_addtype NoDelete, "binary(1)", "NULL"
exec sp_bindefault DefFlag, NoDelete
go

exec sp_addtype DateMove, "smalldatetime", "NULL"
go

exec sp_addtype DatePur, "smalldatetime", "NOT NULL"
go

exec sp_addtype DateStamp, "smalldatetime", "NOT NULL"
go

exec sp_addtype ID, "int", "NOT NULL"
go

exec sp_addtype IDcomp, "int", "NOT NULL"
go

exec sp_addtype IDdepart, "int", "NOT NULL"
go

exec sp_addtype IDhard, "int", "NOT NULL"
go

exec sp_addtype IDmark, "int", "NOT NULL"
go

exec sp_addtype IDsupplier, "int", "NOT NULL"
go

exec sp_addtype IDtype, "int", "NOT NULL"
go

exec sp_addtype IDuser, "int", "NOT NULL"
go

exec sp_addtype NoRoom, "smallint", "NOT NULL"
go

exec sp_addtype WarrMonth, "tinyint", "NOT NULL"
go

exec sp_addtype Adress, "varchar(100)", "NOT NULL"
go

exec sp_addtype Bank, "varchar(250)", "NOT NULL"
go

exec sp_addtype ContactPerson, "varchar(40)", "NOT NULL"
go

exec sp_addtype Definition, "varchar(250)", "NOT NULL"
go

exec sp_addtype Email, "varchar(20)", "NOT NULL"
go

exec sp_addtype Fax, "varchar(20)", "NOT NULL"
go

exec sp_addtype Invoice, "varchar(50)", "NOT NULL"
go

exec sp_addtype InvOrder, "varchar(50)", "NOT NULL"
go

exec sp_addtype LabelNo, "varchar(20)", "NOT NULL"
go

exec sp_addtype Name, "varchar(50)", "NOT NULL"
go

exec sp_addtype Note, "varchar(250)", "NOT NULL"
go

exec sp_addtype PayOrder, "varchar(50)", "NOT NULL"
go

exec sp_addtype Phone, "varchar(20)", "NOT NULL"
go

exec sp_addtype SerialNo, "varchar(20)", "NOT NULL"
go

exec sp_addtype UserName, "varchar(20)", "NOT NULL"
go

exec sp_addtype WarrDoc, "varchar(50)", "NOT NULL"
go

exec sp_addtype WayBill, "varchar(50)", "NOT NULL"
go

exec sp_addtype WWWadress, "varchar(50)", "NOT NULL"
go

CREATE TABLE CompNotes (
       IDcomp               int NOT NULL,
       DateNote             datetime NOT NULL,
       Note                 Note NULL
)
go


ALTER TABLE CompNotes
       ADD PRIMARY KEY (IDcomp, DateNote)
go


exec sp_bindefault DF__Orders__OrderDat__0EC32C7A, 'CompNotes.DateNote'
go

CREATE TABLE CompUser (
       IDcomp               int NOT NULL,
       IDuser               int NOT NULL,
       DateMove             DateMove NOT NULL,
       LastOwner            bit NULL
)
go


ALTER TABLE CompUser
       ADD PRIMARY KEY (IDcomp, IDuser, DateMove)
go


exec sp_bindefault DefUser, 'CompUser.IDuser'
exec sp_bindefault DF__Orders__OrderDat__0EC32C7A, 'CompUser.DateMove'
exec sp_bindefault DefLOwner, 'CompUser.LastOwner'
go

CREATE TABLE Computer (
       IDcomp               IDcomp IDENTITY(1,1),
       LabelNo              LabelNo NULL,
       SerialNo             SerialNo NULL,
       IDsupplier           int NOT NULL,
       IDmark               int NOT NULL,
       DatePur              DatePur NULL,
       WarrMonth            WarrMonth NULL,
       WarrDoc              WarrDoc NULL,
       Invoice              Invoice NULL,
       PayOrder             PayOrder NULL,
       WayBill              WayBill NULL,
       InvOrder             InvOrder NULL,
       Definition           Definition NULL
)
go

CREATE UNIQUE INDEX LabelNoIDX ON Computer
(
       LabelNo
)
go

CREATE INDEX SerialNoIDX ON Computer
(
       SerialNo
)
go


ALTER TABLE Computer
       ADD PRIMARY KEY (IDcomp)
go


exec sp_bindefault DefID, 'Computer.IDsupplier'
exec sp_bindefault DefID, 'Computer.IDmark'
go

CREATE TABLE ComputerMark (
       IDmark               IDmark IDENTITY(1,1),
       IDtype               int NOT NULL,
       Name                 Name NULL,
       NoDelete             bit NULL
)
go


ALTER TABLE ComputerMark
       ADD PRIMARY KEY (IDmark)
go


exec sp_bindefault DefID, 'ComputerMark.IDtype'
exec sp_bindefault DefNoname, 'ComputerMark.Name'
exec sp_bindefault DefFlag, 'ComputerMark.NoDelete'
go

CREATE TABLE ComputerType (
       IDtype               IDtype IDENTITY(1,1),
       NoDelete             bit NULL,
       Name                 Name NULL
)
go


ALTER TABLE ComputerType
       ADD PRIMARY KEY (IDtype)
go


exec sp_bindefault DefFlag, 'ComputerType.NoDelete'
go

CREATE TABLE Department (
       IDdepart             IDdepart IDENTITY(1,1),
       Name                 Name NULL,
       NoDelete             bit NULL
)
go


ALTER TABLE Department
       ADD PRIMARY KEY (IDdepart)
go


exec sp_bindefault DefFlag, 'Department.NoDelete'
go

CREATE TABLE DeviceMark (
       IDmark               IDmark IDENTITY(1,1),
       IDtype               int NOT NULL,
       Name                 Name NULL,
       NoDelete             bit NULL
)
go


ALTER TABLE DeviceMark
       ADD PRIMARY KEY (IDmark)
go


exec sp_bindefault DefID, 'DeviceMark.IDtype'
exec sp_bindefault DefNoname, 'DeviceMark.Name'
exec sp_bindefault DefFlag, 'DeviceMark.NoDelete'
go

CREATE TABLE DeviceType (
       IDtype               IDtype IDENTITY(1,1),
       NoDelete             bit NULL,
       Name                 Name NULL,
       External             bit NULL,
       ExtDataPrompt        bit NULL,
       ExtDataHead          varchar(20) NULL
)
go


ALTER TABLE DeviceType
       ADD PRIMARY KEY (IDtype)
go


exec sp_bindefault DefFlag, 'DeviceType.NoDelete'
exec sp_bindefault DefFlag, 'DeviceType.External'
exec sp_bindefault DefFlag, 'DeviceType.ExtDataPrompt'
go


CREATE TABLE InternalDevice (
       IDcomp               int NOT NULL,
       IDhard               IDhard IDENTITY(1,1) NOT NULL,
       IDmark               int NOT NULL,
       DatePur              DatePur NULL,
       Note                 Note NULL,
       ExtData              varchar(20) NULL
)
go

CREATE INDEX ExtDataIDX ON InternalDevice
(
       ExtData
)
go


ALTER TABLE InternalDevice
       ADD PRIMARY KEY (IDcomp, IDhard)
go


exec sp_bindefault DefInterMark, 'InternalDevice.IDmark'
go

CREATE TABLE Peripheral (
       IDhard               IDhard IDENTITY(1,1),
       LabelNo              LabelNo NULL,
       SerialNo             SerialNo NULL,
       IDsupplier           int NOT NULL,
       IDmark               int NOT NULL,
       DatePur              DatePur NULL,
       WarrMonth            WarrMonth NULL,
       WarrDoc              WarrDoc NULL,
       Invoice              Invoice NULL,
       PayOrder             PayOrder NULL,
       WayBill              WayBill NULL,
       InvOrder             InvOrder NULL,
       Definition           Definition NULL,
       ExtData              varchar(20) NULL
)
go

CREATE UNIQUE INDEX LabelNoIDX ON Peripheral
(
       LabelNo
)
go

CREATE INDEX ExtDataIDX ON Peripheral
(
       ExtData
)
go

CREATE INDEX SerialNoIDX ON Peripheral
(
       SerialNo
)
go


ALTER TABLE Peripheral
       ADD PRIMARY KEY (IDhard)
go


exec sp_bindefault DefID, 'Peripheral.IDsupplier'
go

CREATE TABLE PerNotes (
       IDhard               int NOT NULL,
       DateNote             datetime NOT NULL,
       Note                 Note NULL
)
go


ALTER TABLE PerNotes
       ADD PRIMARY KEY (IDhard, DateNote)
go


exec sp_bindefault DF__Orders__OrderDat__0EC32C7A, 'PerNotes.DateNote'
go

CREATE TABLE PerUser (
       IDhard               int NOT NULL,
       IDuser               int NOT NULL,
       DateMove             DateMove NOT NULL,
       LastOwner            bit NULL
)
go


ALTER TABLE PerUser
       ADD PRIMARY KEY (IDhard, IDuser, DateMove)
go


exec sp_bindefault DefUser, 'PerUser.IDuser'
exec sp_bindefault DF__Orders__OrderDat__0EC32C7A, 'PerUser.DateMove'
exec sp_bindefault DefLOwner, 'PerUser.LastOwner'
go

CREATE TABLE Supplier (
       IDsupplier           IDsupplier IDENTITY(1,1),
       Name                 Name NULL,
       Adress               Adress NULL,
       Bank                 Bank NULL,
       Phone                Phone NULL,
       Fax                  Fax NULL,
       E_Mail               Email NULL,
       WWWadress            WWWadress NULL,
       ContactPerson        ContactPerson NULL,
       Note                 Note NULL,
       NoDelete             bit NULL,
       ContactPhone         varchar(20) NULL
)
go


ALTER TABLE Supplier
       ADD PRIMARY KEY (IDsupplier)
go


exec sp_bindefault DefFlag, 'Supplier.NoDelete'
go

CREATE TABLE UserList (
       IDuser               IDuser IDENTITY(1,1),
       IDdepart             int NOT NULL,
       Name                 Name NULL,
       NoRoom               NoRoom NULL,
       NoDelete             bit NULL
)
go


ALTER TABLE UserList
       ADD PRIMARY KEY (IDuser)
go


exec sp_bindefault DefID, 'UserList.IDdepart'
exec sp_bindefault DefFlag, 'UserList.NoDelete'
go

CREATE PROCEDURE AddCMark 
 @Name NAME,
 @IDtype IDTYPE=1
 AS
/* --------------------------------- */
/*     */
/*              */
/* --------------------------------- */
BEGIN
 /*   */
 INSERT INTO ComputerMark (IDtype,Name,NoDelete)
  VALUES (@IDtype,@Name,0)

 /*   */
 SELECT * FROM Computermark WHERE IDmark=@@IDENTITY
END
go

CREATE PROCEDURE AddCType
 @Name NAME
 AS
/* --------------------------------- */
/*     */
/*              */
/* --------------------------------- */
BEGIN
 /*   */
 INSERT INTO ComputerType (Name,NoDelete)
  VALUES (@Name,0)
 
 /*   */ 
 SELECT * FROM ComputerType WHERE IDtype=@@IDENTITY
END
go

CREATE PROCEDURE AddComputer 
 @LabelNo LABELNO,
 @SerialNo SERIALNO,
 @IDsupplier IDSUPPLIER,
 @IDmark  IDMARK,
 @DatePur DATETIME,
 @WarrMonth TINYINT,
 @WarrDoc WARRDOC,
 @Invoice INVOICE,
 @PayOrder PAYORDER,
 @WayBill WAYBILL,
 @InvOrder INVORDER,
 @Definition DEFINITION=''
AS
/* ------------------------------------- */
/*     */
/* ------------------------------------- */
BEGIN
 /*   */
 INSERT INTO Computer (LabelNo,SerialNo,IDsupplier,IDmark,DatePur,WarrMonth,WarrDoc,Invoice,PayOrder,WayBill,InvOrder,Definition)
  VALUES (@LabelNo,@SerialNo,@IDsupplier,@IDmark,@DatePur,@WarrMonth,@WarrDoc,@Invoice,@PayOrder,@WayBill,@InvOrder,@Definition)

 /*    */
 SELECT * FROM Computer WHERE IDcomp=@@IDENTITY
END
go

CREATE PROCEDURE AddDepartment
 @Name NAME
 AS
/* ------------------------- */
/*    */
/*      */
/* ------------------------- */
BEGIN
 /*   */
 INSERT INTO Department (Name,NoDelete)
  VALUES (@Name,0)
 
 /*   */ 
 SELECT * FROM Department WHERE IDdepart=@@IDENTITY
END
go

CREATE PROCEDURE AddIDevice 
 @IDcomp  IDCOMP,
 @IDmark  IDMARK,
 @DatePur DATETIME,
 @Note  NOTE,
 @ExtData VARCHAR(20)=''
 AS
/* ---------------------------------------- */
/*      */
/* ---------------------------------------- */
BEGIN
 /*   */
 INSERT INTO InternalDevice (IDcomp,IDmark,DatePur,Note,ExtData)
  VALUES (@IDcomp,@IDmark,@DatePur,@Note,@ExtData)
 
 /*    */
 SELECT * FROM InternalDevice WHERE IDhard=@@IDENTITY
END
go

CREATE PROCEDURE AddPMark 
 @Name NAME,
 @IDtype IDTYPE=1
 AS
/* --------------------------------- */
/*     */
/*              */
/* --------------------------------- */
BEGIN
 /*   */
 INSERT INTO DeviceMark (IDtype,Name,NoDelete)
  VALUES (@IDtype,@Name,0)

 /*   */
 SELECT * FROM DeviceMark WHERE IDmark=@@IDENTITY
END
go

CREATE PROCEDURE AddPType
 @Name  NAME,
 @External EXTERNAL,
 @ExtDataHead VARCHAR(20)=NULL
 AS
/* --------------------------------- */
/*      */
/*              */
/* --------------------------------- */
BEGIN
 /*   */
 IF ISNULL(@ExtDataHead,'NULL')='NULL' 
  INSERT INTO DeviceType (Name,External,NoDelete,ExtDataHead,ExtDataPrompt)
   VALUES (@Name,@External,0,@ExtDataHead,0)
 ELSE
  INSERT INTO DeviceType (Name,External,NoDelete,ExtDataHead,ExtDataPrompt)
   VALUES (@Name,@External,0,@ExtDataHead,1)
 
 
 /*   */ 
 SELECT * FROM DeviceType WHERE IDtype=@@IDENTITY
END
go

CREATE PROCEDURE AddPeripheral
 @LabelNo LABELNO,
 @SerialNo SERIALNO,
 @IDsupplier IDSUPPLIER,
 @IDmark  IDMARK,
 @DatePur DATETIME,
 @WarrMonth TINYINT,
 @WarrDoc WARRDOC,
 @Invoice INVOICE,
 @PayOrder PAYORDER,
 @WayBill WAYBILL,
 @InvOrder INVORDER,
 @ExtData VARCHAR(20),
 @Definition DEFINITION=''
AS
/* ------------------------------------- */
/*     */
/* ------------------------------------- */
BEGIN
 /*   */
 INSERT INTO Peripheral (LabelNo,SerialNo,IDsupplier,IDmark,DatePur,WarrMonth,WarrDoc,Invoice,PayOrder,WayBill,InvOrder,Definition,ExtData)
  VALUES (@LabelNo,@SerialNo,@IDsupplier,@IDmark,@DatePur,@WarrMonth,@WarrDoc,@Invoice,@PayOrder,@WayBill,@InvOrder,@Definition,@ExtData)

 /*    */
 SELECT * FROM Peripheral WHERE IDhard=@@IDENTITY
END
go

CREATE PROCEDURE AddSupplier 
 @Name  NAME,
 @Adress  ADRESS,
 @Bank  BANK,
 @Phone  PHONE,
 @Fax  FAX,
 @E_mail  EMAIL,
 @WWWadress WWWadress,
 @ContactPerson CONTACTPERSON,
 @ContactPhone PHONE,
 @Note  NOTE
 AS
/* ---------------------------- */
/*    */
/* ---------------------------- */
BEGIN
 /*   */
 INSERT INTO Supplier (Name,Adress,Bank,Phone,Fax,E_mail,WWWadress,ContactPerson,Note,ContactPhone,NoDelete)
  VALUES (@Name,@Adress,@Bank,@Phone,@Fax,@E_mail,@WWWadress,@ContactPerson,@Note,@ContactPhone,0)
 /*    */
 SELECT * FROM Supplier WHERE IDsupplier=@@IDENTITY
END
go

CREATE PROCEDURE AddUser 
 @Name  NAME,
 @NoRoom  SMALLINT,
 @IDdepart IDDEPART=1
 AS
/* ------------------------------ */
/*    */
/* ------------------------------ */
BEGIN
 /*   */
 INSERT INTO UserList (Name,Noroom,IDdepart,NoDelete)
  VALUES (@Name,@NoRoom,@IDdepart,0)

 /*   */
 SELECT * FROM UserList WHERE IDuser=@@IDENTITY
END
go

CREATE PROCEDURE ChkConnect 
 @DBname VARCHAR(40)=NULL
 AS
BEGIN
 IF ISNULL(@DBname,'NULL')='NULL' OR UPPER(@DBname)<>'COMPUTERS'
  RAISERROR 99999 '  '
END
go

CREATE PROCEDURE ChkLN 
 @LabelNo LABELNO
 AS
/* ------------------------------------------ */
/*       */
/* ------------------------------------------ */
BEGIN
 IF EXISTS (SELECT LabelNo FROM Computer WHERE LabelNo=@LabelNo) OR
  EXISTS (SELECT LabelNo FROM Peripheral WHERE LabelNo=@LabelNo)
  RAISERROR 99999 '    '
 ELSE
  RETURN 0
END
go

CREATE PROCEDURE CreateSystemRecords 
 AS
/* -------------------------------------------------------- */
/*                     */
/* !!!         !!! */
/* -------------------------------------------------------- */
BEGIN
 IF EXISTS (SELECT * FROM Computer) RAISERROR 99999 '    '

/*          */
 DELETE FROM ComputerMark
 DELETE FROM ComputerType
 
 SET IDENTITY_INSERT ComputerType ON
 INSERT INTO ComputerType (IDtype,Name,NoDelete) VALUES (1,'( )',1)
 INSERT INTO ComputerType (IDtype,Name,NoDelete) VALUES (2,' ',1)
 INSERT INTO ComputerType (IDtype,Name,NoDelete) VALUES (3,'',1)
 INSERT INTO ComputerType (IDtype,Name,NoDelete) VALUES (4,'',1)
 INSERT INTO ComputerType (IDtype,Name,NoDelete) VALUES (5,' ',1)
 SET IDENTITY_INSERT ComputerType OFF

 SET IDENTITY_INSERT ComputerMark ON
 INSERT INTO ComputerMark (IDmark,IDtype,Name,NoDelete) VALUES (1,1,'()',1)
 INSERT INTO ComputerMark (IDmark,IDtype,Name,NoDelete) VALUES (2,2,'()',1)
 INSERT INTO ComputerMark (IDmark,IDtype,Name,NoDelete) VALUES (3,3,'()',1)
 INSERT INTO ComputerMark (IDmark,IDtype,Name,NoDelete) VALUES (4,4,'()',1)
 INSERT INTO ComputerMark (IDmark,IDtype,Name,NoDelete) VALUES (5,5,'()',1)
 SET IDENTITY_INSERT ComputerMark OFF

/*          */
 DELETE FROM DeviceMark
 DELETE FROM DeviceType
 
 SET IDENTITY_INSERT DeviceType ON
 INSERT INTO DeviceType (IDtype,ExtDataHead,Name,External,NoDelete) VALUES (1,'','( )',1,1)
 INSERT INTO DeviceType (IDtype,ExtDataHead,Name,External,NoDelete) VALUES (2,'','( )',0,1)

  /*   */
 INSERT INTO DeviceType (IDtype,ExtDataHead,Name,External,NoDelete,ExtDataPrompt) VALUES (3,' "',' ',1,1,1)
 INSERT INTO DeviceType (IDtype,ExtDataHead,Name,External,NoDelete,ExtDataPrompt) VALUES (4,' "',' ',1,1,1)
 INSERT INTO DeviceType (IDtype,ExtDataHead,Name,External,NoDelete) VALUES (5,'','',1,1)
 INSERT INTO DeviceType (IDtype,ExtDataHead,Name,External,NoDelete) VALUES (6,'','',1,1)
 INSERT INTO DeviceType (IDtype,ExtDataHead,Name,External,NoDelete,ExtDataPrompt) VALUES (7,'',' ',1,1,1)
 INSERT INTO DeviceType (IDtype,ExtDataHead,Name,External,NoDelete,ExtDataPrompt) VALUES (8,'',' ',1,1,1)
 INSERT INTO DeviceType (IDtype,ExtDataHead,Name,External,NoDelete,ExtDataPrompt) VALUES (9,'',' ',1,1,1)
 INSERT INTO DeviceType (IDtype,ExtDataHead,Name,External,NoDelete,ExtDataPrompt) VALUES (10,' Mb',' ',1,1,1)
 INSERT INTO DeviceType (IDtype,ExtDataHead,Name,External,NoDelete,ExtDataPrompt) VALUES (11,'','',1,1,1)
 INSERT INTO DeviceType (IDtype,ExtDataHead,Name,External,NoDelete,ExtDataPrompt) VALUES (12,'',' ',1,1,1)

 /*   */
 INSERT INTO DeviceType (IDtype,ExtDataHead,Name,External,NoDelete,ExtDataPrompt) VALUES (13,'',' ',0,1,1)
 INSERT INTO DeviceType (IDtype,ExtDataHead,Name,External,NoDelete,ExtDataPrompt) VALUES (14,' MHZ','',0,1,1)
 INSERT INTO DeviceType (IDtype,ExtDataHead,Name,External,NoDelete,ExtDataPrompt) VALUES (15,' Mb',' ',0,1,1)
 INSERT INTO DeviceType (IDtype,ExtDataHead,Name,External,NoDelete,ExtDataPrompt) VALUES (16,' Mb','',0,1,1)
 INSERT INTO DeviceType (IDtype,ExtDataHead,Name,External,NoDelete,ExtDataPrompt) VALUES (17,' Mb',' ',0,1,1)
 INSERT INTO DeviceType (IDtype,ExtDataHead,Name,External,NoDelete,ExtDataPrompt) VALUES (18,' ',' CDROM',0,1,1)
 INSERT INTO DeviceType (IDtype,ExtDataHead,Name,External,NoDelete,ExtDataPrompt) VALUES (19,' Mb','  ',0,1,1)
 INSERT INTO DeviceType (IDtype,ExtDataHead,Name,External,NoDelete,ExtDataPrompt) VALUES (20,'MAC ',' ',0,1,1)
 SET IDENTITY_INSERT DeviceType OFF

 SET IDENTITY_INSERT DeviceMark ON
 INSERT INTO DeviceMark (IDmark,IDtype,Name,NoDelete) VALUES (1,1,'()',1)
 INSERT INTO DeviceMark (IDmark,IDtype,Name,NoDelete) VALUES (2,2,'()',1)
 INSERT INTO DeviceMark (IDmark,IDtype,Name,NoDelete) VALUES (3,3,'()',1)
 INSERT INTO DeviceMark (IDmark,IDtype,Name,NoDelete) VALUES (4,4,'()',1)
 INSERT INTO DeviceMark (IDmark,IDtype,Name,NoDelete) VALUES (5,5,'()',1)
 INSERT INTO DeviceMark (IDmark,IDtype,Name,NoDelete) VALUES (6,6,'()',1)
 INSERT INTO DeviceMark (IDmark,IDtype,Name,NoDelete) VALUES (7,7,'()',1)
 INSERT INTO DeviceMark (IDmark,IDtype,Name,NoDelete) VALUES (8,8,'()',1)
 INSERT INTO DeviceMark (IDmark,IDtype,Name,NoDelete) VALUES (9,9,'()',1)
 INSERT INTO DeviceMark (IDmark,IDtype,Name,NoDelete) VALUES (10,10,'()',1)
 INSERT INTO DeviceMark (IDmark,IDtype,Name,NoDelete) VALUES (11,11,'()',1)
 INSERT INTO DeviceMark (IDmark,IDtype,Name,NoDelete) VALUES (12,12,'()',1)
 INSERT INTO DeviceMark (IDmark,IDtype,Name,NoDelete) VALUES (13,13,'()',1)
 INSERT INTO DeviceMark (IDmark,IDtype,Name,NoDelete) VALUES (14,14,'()',1)
 INSERT INTO DeviceMark (IDmark,IDtype,Name,NoDelete) VALUES (15,15,'()',1)
 INSERT INTO DeviceMark (IDmark,IDtype,Name,NoDelete) VALUES (16,16,'()',1)
 INSERT INTO DeviceMark (IDmark,IDtype,Name,NoDelete) VALUES (17,17,'()',1)
 INSERT INTO DeviceMark (IDmark,IDtype,Name,NoDelete) VALUES (18,18,'()',1)
 INSERT INTO DeviceMark (IDmark,IDtype,Name,NoDelete) VALUES (19,19,'()',1)
 INSERT INTO DeviceMark (IDmark,IDtype,Name,NoDelete) VALUES (20,20,'()',1)
 SET IDENTITY_INSERT DeviceMark OFF

/*         */
 DELETE FROM UserList
 DELETE FROM Department
 
 SET IDENTITY_INSERT Department ON
 INSERT INTO Department (IDdepart,Name,Nodelete) VALUES (1,'( )',1)
 INSERT INTO Department (IDdepart,Name,Nodelete) VALUES (2,'',1)
 SET IDENTITY_INSERT Department OFF

 SET IDENTITY_INSERT UserList ON
 INSERT INTO UserList (IDuser,IDdepart,Name,NoRoom,Nodelete) VALUES (1,1,'()',0,1)
 INSERT INTO UserList (IDuser,IDdepart,Name,NoRoom,Nodelete) VALUES (2,2,'()',0,1)
 SET IDENTITY_INSERT UserList OFF

/*       */ 
 DELETE FROM Supplier
 SET IDENTITY_INSERT Supplier ON
 INSERT INTO Supplier (IDsupplier,name,Adress,Bank,Phone,Fax,E_Mail,WWWadress,ContactPerson,Note,NoDelete)
  VALUES (1,'( )','','','','','','','','',1)
 SET IDENTITY_INSERT Supplier OFF
END
go

CREATE PROCEDURE DeleteCMark 
 @IDmark IDMARK
 AS
/* ----------------------------- */
/*        */
/* ----------------------------- */
BEGIN
 IF EXISTS(SELECT IDmark FROM Computer WHERE IDmark=@IDmark )
  BEGIN
   RAISERROR 99999 '   '
   RETURN
  END

 IF EXISTS(SELECT IDmark FROM ComputerMark WHERE IDmark=@IDmark AND NoDelete=1)
  BEGIN
   RAISERROR 99999 '   '
   RETURN
  END

 ELSE
  /*   */
  DELETE ComputerMark 
   WHERE IDmark=@IDmark
END
go

CREATE PROCEDURE DeleteCNote 
 @IDcomp  IDCOMP,
 @DateNote DATETIME =NULL
 AS
/* ------------------------------------------------ */
/*  ()                */
/*    ,            */
/*  ,     */
/* ------------------------------------------------ */
BEGIN
 IF ISNULL(@DateNote,1)=1 
  DELETE CompNotes
   WHERE IDcomp=@IDcomp
 ELSE
  DELETE CompNotes
   WHERE IDcomp=@IDcomp AND DateNote=@DateNote

END
go

CREATE PROCEDURE DeleteCType 
 @IDtype IDTYPE
 AS
/* ------------------------ */
/*    */
/* ------------------------ */
BEGIN
 /*    */
 IF EXISTS(SELECT IDtype FROM ComputerType WHERE IDtype=@IDtype AND NoDelete=1)
  RAISERROR 99999 '   '
 ELSE
 IF NOT EXISTS(SELECT IDmark FROM ComputerMark WHERE IDtype=@IDtype)
  DELETE ComputerType WHERE IDtype=@IDtype
 ELSE
  RAISERROR 99999 '  ,  '
END
go

CREATE PROCEDURE DeleteComputer 
 @IDcomp IDCOMP
 AS
/* ------------------------- */
/*     */
/* ------------------------- */
BEGIN
 IF EXISTS(SELECT IDcomp FROM CompUser WHERE IDcomp=@IDcomp AND IDuser<>1 AND LastOwner=1)
 BEGIN
  RAISERROR 99999 '    '
  RETURN
 END
 ELSE
 BEGIN TRAN
  /*   */
  DELETE CompNotes WHERE IDcomp=@IDcomp
 
  /*   */
  DELETE InternalDevice WHERE IDcomp=@IDcomp

  /*     */
  DELETE CompUser WHERE IDcomp=@IDcomp

  /*   */
  DELETE Computer WHERE IDcomp=@IDcomp
 COMMIT TRAN
END
go

CREATE PROCEDURE DeleteDepartment
 @IDdepart IDDEPART
 AS
/* ------------------------ */
/*    */
/* ------------------------ */
BEGIN
 /*    */
 IF EXISTS(SELECT IDdepart FROM Department WHERE IDdepart=@IDdepart AND NoDelete=1)
  RAISERROR 99999 '   '
 ELSE
 IF NOT EXISTS(SELECT IDdepart FROM UserList WHERE IDdepart=@IDdepart)
  DELETE Department WHERE IDdepart=@IDdepart
 ELSE
  RAISERROR 99999 '  ,  '
END
go

CREATE PROCEDURE DeleteIDevice 
 @IDcomp IDCOMP,
 @IDhard IDHARD
 AS
/* --------------------------------- */
/*     */
/* --------------------------------- */
BEGIN
 DELETE InternalDevice WHERE IDcomp=@IDcomp AND IDhard=@IDhard
END
go

CREATE PROCEDURE DeletePMark 
 @IDmark IDMARK
 AS
/* ----------------------------- */
/*        */
/* ----------------------------- */
BEGIN
 IF EXISTS(SELECT IDmark FROM Peripheral WHERE IDmark=@IDmark ) OR
  EXISTS(SELECT IDmark FROM InternalDevice WHERE IDmark=@IDmark )
  BEGIN
   RAISERROR 99999 '   '
   RETURN
  END

 IF EXISTS(SELECT IDmark FROM DeviceMark WHERE IDmark=@IDmark AND NoDelete=1)
  BEGIN
   RAISERROR 99999 '   '
   RETURN
  END

 ELSE
  /*   */
  DELETE DeviceMark 
   WHERE IDmark=@IDmark
END
go

CREATE PROCEDURE DeletePNote 
 @IDhard  IDHARD,
 @DateNote DATETIME =NULL
 AS
/* ------------------------------------------------ */
/*  ()                */
/*    ,            */
/*  ,     */
/* ------------------------------------------------ */
BEGIN
 IF ISNULL(@DateNote,1)=1 
  DELETE PerNotes
   WHERE IDhard=@IDhard
 ELSE
  DELETE PerNotes
   WHERE IDhard=@IDhard AND DateNote=@DateNote

END
go

CREATE PROCEDURE DeletePType 
 @IDtype IDTYPE
 AS
/* ------------------------ */
/*    */
/* ------------------------ */
BEGIN
 /*    */
 IF EXISTS(SELECT IDtype FROM DeviceType WHERE IDtype=@IDtype AND NoDelete=1)
  RAISERROR 99999 '   '
 ELSE
 IF NOT EXISTS(SELECT IDmark FROM DeviceMark WHERE IDtype=@IDtype)
  DELETE DeviceType WHERE IDtype=@IDtype
 ELSE
  RAISERROR 99999 '  ,  '
END
go

CREATE PROCEDURE DeletePeripheral 
 @IDhard IDHARD
 AS
/* ----------------------------------------*/
/*      */
/* --------------------------------------- */
BEGIN IF EXISTS(SELECT IDhard FROM PerUser WHERE IDhard=@IDhard AND IDuser<>1 AND LastOwner=1)
 BEGIN
  RAISERROR 99999 '    '
  RETURN
 END
 ELSE BEGIN TRAN
  /*   */
  DELETE PerNotes WHERE IDhard=@IDhard
 
  /*     */
  DELETE PerUser WHERE IDhard=@IDhard

  /*   */
  DELETE Peripheral WHERE IDhard=@IDhard
 COMMIT TRAN
END
go

CREATE PROCEDURE DeleteSupplier 
 @IDsupplier IDSUPPLIER
 AS
/* ---------------------------- */
/*     */
/* ---------------------------- */
BEGIN

 IF EXISTS(SELECT IDsupplier FROM Supplier WHERE IDsupplier=@IDsupplier AND NoDelete=1)
  RAISERROR 99999 '   '

 ELSE
  IF EXISTS(SELECT IDsupplier FROM Computer WHERE IDsupplier=@IDsupplier) OR
   EXISTS(SELECT IDsupplier FROM Peripheral WHERE IDsupplier=@IDsupplier)
   RAISERROR 99999 '    '
  ELSE
   /*   */
   DELETE Supplier
    WHERE IDsupplier=@IDsupplier
END
go

CREATE PROCEDURE DeleteUser 
 @IDuser IDUSER
 AS
/* ------------------------------ */
/*    */
/* ------------------------------ */
BEGIN
 IF EXISTS(SELECT IDuser FROM UserList WHERE IDuser=@IDuser AND NoDelete=1)
  RAISERROR 99999 '   '
 ELSE
  IF EXISTS(SELECT IDuser FROM CompUser WHERE IDuser=@IDuser)
   OR EXISTS(SELECT IDuser FROM PerUser WHERE IDuser=@IDuser)
   RAISERROR 99999 '    '
  ELSE
   DELETE UserList WHERE IDuser=@IDuser
END
go

CREATE PROCEDURE EditCNote 
 @IDcomp  IDCOMP,
 @DateNote DATETIME,
 @Note  NOTE
 AS
/* ----------------------------------------------- */
/*      */
/* ----------------------------------------------- */
BEGIN 
 IF EXISTS (SELECT IDcomp FROM CompNotes WHERE IDcomp=@IDcomp AND DateNote=@DateNote)
  UPDATE CompNotes
   SET Note=@Note
   WHERE IDcomp=@IDcomp AND DateNote=@DateNote
 ELSE
  INSERT INTO CompNotes (IDcomp,DateNote,Note)
   VALUES (@IDcomp,@DateNote,@Note)
END
go

CREATE PROCEDURE EditPNote 
 @IDhard  IDHARD,
 @DateNote DATETIME,
 @Note  NOTE
 AS
/* ----------------------------------------------- */
/*      */
/* ----------------------------------------------- */
BEGIN
 IF EXISTS (SELECT IDhard FROM PerNotes WHERE IDhard=@IDhard AND DateNote=@DateNote)
  UPDATE PerNotes
   SET Note=@Note
   WHERE IDhard=@IDhard AND DateNote=@DateNote
 ELSE
  INSERT INTO PerNotes (IDhard,DateNote,Note)
   VALUES (@IDhard,@DateNote,@Note)
END
go

CREATE PROCEDURE GetCHistory 
 @IDcomp IDCOMP
 AS
/* -------------------------------------------------------- */
/*    ""  */
/* -------------------------------------------------------- */
BEGIN
 SELECT CU.LastOwner,CU.IDuser,CU.DateMove,UL.Name AS UserName,DP.Name AS Department
  FROM CompUser CU,UserList UL,Department DP
  WHERE CU.IDcomp=@IDcomp 
   AND CU.IDuser=UL.IDuser
   AND UL.IDdepart=DP.IDdepart
  ORDER BY CU.DateMove
END
go

CREATE PROCEDURE GetCInternalList 
 @IDcomp IDCOMP
 AS
/* ---------------------------------------- */
/*     */
/*                          */
/* ---------------------------------------- */
BEGIN
 SELECT DT.Name AS Type,DM.Name AS Mark,DatePur,DT.ExtDataHead,ID.ExtData,ID.IDcomp,ID.IDhard,ID.IDmark,DT.IDtype,ID.Note
  FROM InternalDevice ID,DeviceMark DM,DeviceType DT
  WHERE ID.IDcomp=@IDcomp 
   AND ID.IDmark=DM.IDmark 
   AND DM.IDtype=DT.IDtype
  ORDER BY 4
END
go

CREATE PROCEDURE GetCMark 
 @IDmark IDMARK
 AS
/* --------------------------------------------- */
/*      */
/* --------------------------------------------- */
BEGIN
 /*   */
 SELECT * FROM ComputerMark WHERE IDmark=@IDmark
END
go

CREATE PROCEDURE GetCMarkList 
 @IDtype IDTYPE
 AS
/* -------------------------------------------------- */
/*        */
/* -------------------------------------------------- */
BEGIN
 SELECT Name,IDmark
  FROM ComputerMark
  WHERE IDtype=@IDtype
  ORDER BY Name
END
go

CREATE PROCEDURE GetCNotes 
 @IDcomp IDCOMP
 AS 
/* ---------------------------------------------------------- */
/*      */
/* ---------------------------------------------------------- */
BEGIN
 SELECT DateNote,Note 
  FROM CompNotes 
  WHERE IDcomp=@IDcomp 
END
go

CREATE PROCEDURE GetCOwner 
 @IDcomp IDCOMP
 AS
/* --------------------------------------------- */
/*      . */
/* --------------------------------------------- */
BEGIN
 SELECT CU.IDuser,UL.Name AS UserName,UL.NoRoom,UL.IDdepart,DP.Name AS Depart,CU.DateMove
  FROM CompUser CU,UserList UL,Department DP
  WHERE CU.IDcomp=@IDcomp 
   AND LastOwner=1
   AND UL.IDuser=CU.IDuser
   AND DP.IDdepart=UL.IDdepart
END
go

CREATE PROCEDURE GetCType 
 @IDtype IDTYPE
 AS
/* ------------------------------------------- */
/*      */
/* ------------------------------------------- */
BEGIN
 SELECT * FROM ComputerType WHERE IDtype=@IDtype
END
go

CREATE PROCEDURE GetCTypeList 
 AS
/* ------------------------------------- */
/*     */
/* ------------------------------------- */
BEGIN
 SELECT Name,IDtype
  FROM ComputerType
  ORDER BY Name
END
go

CREATE PROCEDURE GetCompList 
 @IDtype IDTYPE,
 @Sort SMALLINT=0
 AS
/* -------------------------------------------------- */
/*      */
/* -------------------------------------------------- */
BEGIN
 IF @Sort=0  SELECT * 
   FROM vwFullCOwnersList
   WHERE IDtype=@IDtype
   ORDER BY LabelNo
 IF @Sort=1  SELECT * 
   FROM vwFullCOwnersList
   WHERE IDtype=@IDtype
   ORDER BY Mark
 IF @Sort=2  SELECT * 
   FROM vwFullCOwnersList
   WHERE IDtype=@IDtype
   ORDER BY UserName
END
go

CREATE PROCEDURE GetComputer 
 @IDcomp IDCOMP
 AS
/* ------------------------------------------------ */
/*      */
/* ------------------------------------------------ */
BEGIN
 SELECT * 
  FROM Computer
  WHERE IDcomp=@IDcomp
END
go

CREATE PROCEDURE GetDUserList 
 @IDdepart IDDEPART
 AS
/* -------------------------------------------- */
/*     */
/* -------------------------------------------- */
BEGIN
 SELECT Name,IDuser,NoRoom
  FROM UserList
  WHERE IDdepart=@IDdepart
  ORDER BY Name
END
go

CREATE PROCEDURE GetDepartList 
 AS
/* --------------------------------- */
/*    */
/* --------------------------------- */
BEGIN
 SELECT Name,IDdepart
  FROM Department
  ORDER BY Name
END
go

CREATE PROCEDURE GetDepartment 
 @IDdepart IDDEPART
 AS
/* ------------------------------------------- */
/*      */
/* ------------------------------------------- */
BEGIN
 SELECT * FROM Department WHERE IDdepart=@IDdepart
END
go

CREATE PROCEDURE GetExtData 
 @IDhard  IDHARD,
 @External EXTERNAL
 AS
/* ----------------------------------- */
/*      */
/*   .*/
/* ----------------------------------- */
BEGIN
 IF @External=1
  SELECT PR.ExtData,DT.ExtDataHead 
   FROM Peripheral PR,DeviceType DT,DeviceMark DM
   WHERE PR.IDhard=@IDhard 
    AND DM.IDmark=PR.IDmark
    AND DT.IDtype=DM.IDtype
 ELSE
  SELECT ID.ExtData,DT.ExtDataHead 
   FROM InternalDevice ID,DeviceType DT,DeviceMark DM
   WHERE ID.IDhard=@IDhard 
    AND DM.IDmark=ID.IDmark
    AND DT.IDtype=DM.IDtype

END
go

CREATE PROCEDURE GetIDevice 
 @IDcomp IDCOMP,
 @IDhard IDHARD
 AS
/* ----------------------------------------- */
/*      */
/*                      */
/* ----------------------------------------- */
BEGIN
 SELECT * 
  FROM InternalDevice 
  WHERE IDcomp=@IDcomp 
   AND IDhard=@IDhard
END
go

CREATE PROCEDURE GetLNComputer 
 @LabelNo LABELNO
 AS
/* ----------------------------------------- */
/*      */
/* ----------------------------------------- */
BEGIN
 SELECT * 
  FROM Computer
  WHERE LabelNo=@LabelNo
END
go

CREATE PROCEDURE GetLNPeripheral
 @LabelNo LABELNO
 AS
/* ----------------------------------------- */
/*      */
/* ----------------------------------------- */
BEGIN
 SELECT * 
  FROM Peripheral
  WHERE LabelNo=@LabelNo
END
go

CREATE PROCEDURE GetListDComp 
 AS
/* ---------------------------------------- */
/*     */
/*          */
/* ---------------------------------------- */

BEGIN
 SELECT DP.Name AS Department,OL.DatePur,OL.Type,OL.Mark,PL.Mark AS Processor,PL.ExtData AS Freq,RL.Mark AS Ram,RL.ExtData AS Size
 FROM vwFullCOwnersList OL 
  LEFT JOIN vwProcList PL
   ON PL.IDcomp=OL.IDcomp
  LEFT JOIN vwRamList RL 
   ON RL.IDcomp=OL.IDcomp
  LEFT JOIN Department DP
   ON DP.IDdepart=OL.IDdepart
 ORDER BY Department,Type,DatePur 
END
go

CREATE PROCEDURE GetPHistory 
 @IDhard IDhard
 AS
/* -------------------------------------------------------- */
/*    ""  */
/* -------------------------------------------------------- */
BEGIN
 SELECT PU.LastOwner,PU.IDuser,PU.DateMove,UL.Name UserName,DP.Name AS Department
  FROM PerUser PU,UserList UL,Department DP
  WHERE PU.IDhard=@IDhard 
   AND PU.IDuser=UL.IDuser 
   AND DP.IDdepart=UL.IDdepart
  ORDER BY PU.DateMove
END
go

CREATE PROCEDURE GetPMark
 @IDmark IDMARK
 AS
/* ----------------------------------------- */
/*        */
/* ----------------------------------------- */
BEGIN
 SELECT *
  FROM DeviceMark
  WHERE IDmark=@IDmark
END
go

CREATE PROCEDURE GetPMarkList 
 @IDtype IDTYPE
 AS
/* ------------------------------------------------ */
/*        */
/* ------------------------------------------------ */
BEGIN
 SELECT Name,IDmark
  FROM DeviceMark
  WHERE IDtype=@IDtype
  ORDER BY Name
END
go

CREATE PROCEDURE GetPNotes
 @IDhard IDHARD
 AS 
/* ---------------------------------------------------------- */
/*      */
/* ---------------------------------------------------------- */
BEGIN
 SELECT DateNote,Note 
  FROM PerNotes 
  WHERE IDhard=@IDhard 
END
go

CREATE PROCEDURE GetPOwner 
 @IDhard IDHARD
 AS
/* --------------------------------------------- */
/*      . */
/* --------------------------------------------- */
BEGIN
 SELECT PU.IDuser,UL.Name AS UserName,UL.NoRoom,UL.IDdepart,DP.Name AS Depart,PU.DateMove
  FROM PerUser PU,UserList UL,Department DP
  WHERE PU.IDhard=@IDhard 
   AND LastOwner=1
   AND UL.IDuser=PU.IDuser
   AND DP.IDdepart=UL.IDdepart
END
go

CREATE PROCEDURE GetPType 
 @IDtype IDTYPE
 AS
/* ------------------------------------------- */
/*      */
/* ------------------------------------------- */
BEGIN
 SELECT * FROM DeviceType WHERE IDtype=@IDtype
END
go

CREATE PROCEDURE GetPTypeList 
 @External EXTERNAL=1
 AS
/* ----------------------------------- */
/*     */
/* ----------------------------------- */
BEGIN
 SELECT Name,IDtype,ExtDataHead
  FROM DeviceType 
  WHERE External=@External
  ORDER BY Name
END
go

CREATE PROCEDURE GetPerList 
 @IDtype IDTYPE,
 @Sort SMALLINT=0
 AS
/* ------------------------------------------------ */
/*      */
/* ------------------------------------------------ */
BEGIN
 IF @Sort=0  SELECT * 
   FROM vwFullPOwnersList
   WHERE IDtype=@IDtype
   ORDER BY LabelNo
 IF @Sort=1  SELECT * 
   FROM vwFullPOwnersList
   WHERE IDtype=@IDtype
   ORDER BY Mark
 IF @Sort=2  SELECT * 
   FROM vwFullPOwnersList
   WHERE IDtype=@IDtype
   ORDER BY UserName

END
go

CREATE PROCEDURE GetPeripheral
 @IDhard IDHARD
 AS
/* ------------------------------------------------ */
/*      */
/* ------------------------------------------------ */
BEGIN
 SELECT * 
  FROM Peripheral
  WHERE IDhard=@IDhard
END
go

CREATE PROCEDURE GetSNComputer 
 @SerialNo SERIALNO
 AS
/* -------------------------------------------------- */
/*       */
/* -------------------------------------------------- */
BEGIN
 SELECT * 
  FROM Computer
  WHERE SerialNo=@SerialNo
END
go

CREATE PROCEDURE GetSNPeripheral
 @SerialNo SERIALNO
 AS
/* -------------------------------------------------- */
/*       */
/* -------------------------------------------------- */
BEGIN
 SELECT * 
  FROM Peripheral
  WHERE SerialNo=@SerialNo
END
go

CREATE PROCEDURE GetSupplier 
 @IDsupplier IDSUPPLIER
 AS
/* ----------------------------------- */
/*       */
/* ----------------------------------- */
BEGIN
 SELECT * 
  FROM Supplier
  WHERE IDsupplier=@IDsupplier
END
go

CREATE PROCEDURE GetSupplierList 
 AS
/* ------------------------------- */
/*    */
/* ------------------------------- */
BEGIN
 SELECT Name,IDsupplier
  FROM Supplier
  ORDER BY Name
END
go

CREATE PROCEDURE GetUInventory 
 @IDuser IDUSER
 AS
/* --------------------------------------------- */
/*     */
/* --------------------------------------------- */
BEGIN
 SELECT 0 AS External,CP.IDcomp AS IDcode,CT.Name AS Type,CP.LabelNO,CU.DateMove,CM.Name AS Mark
  FROM CompUser CU,ComputerMark CM,Computer CP,ComputerType CT
  WHERE CU.IDuser=@IDuser 
   AND CU.LastOwner=1 
   AND CU.IDcomp=CP.IDcomp 
   AND CP.IDmark=CM.IDmark 
   AND CM.IDtype=CT.IDtype
 UNION ALL
 SELECT 1,PR.IDhard,DT.Name,PR.LabelNO,PU.DateMove,DM.Name
  FROM PerUser PU,DeviceMark DM,Peripheral PR,Devicetype DT
  WHERE PU.IDuser=@IDuser 
   AND PU.LastOwner=1
   AND PU.IDhard=PR.IDhard 
   AND PR.IDmark=DM.IDmark 
   AND DM.IDtype=DT.IDtype
 ORDER BY 1,3
END
go

CREATE PROCEDURE GetUser 
 @IDuser IDUSER
 AS
/* -------------------------------------------------- */
/*       */
/* -------------------------------------------------- */
BEGIN
 SELECT * 
  FROM UserList 
  WHERE IDuser=@IDuser
END
go

CREATE PROCEDURE NewCOwner 
 @IDuser  IDUSER,
 @IDcomp  IDCOMP,
 @DateMove DATETIME=NULL
 AS
/* ---------------------------------------------------- */
/*    ""                 */
/*    ,     */
/* ---------------------------------------------------- */

IF ISNULL(@DateMove,1)=1 SELECT @DateMove=CURRENT_TIMESTAMP
BEGIN TRAN
 /*     */
 UPDATE CompUser 
  SET LastOwner=0
  WHERE IDcomp=@IDcomp 
   AND LastOwner=1

 /*    */
 INSERT INTO CompUser (IDcomp,IDuser,DateMove,LastOwner)
  VALUES (@IDcomp,@IDuser,@DateMove,1)
COMMIT TRAN
go

CREATE PROCEDURE NewPOwner 
 @IDuser  IDUSER,
 @IDhard  IDHARD,
 @DateMove DATETIME=NULL
 AS
/* ---------------------------------------------------- */
/*    ""                 */
/*    ,     */
/* ---------------------------------------------------- */

IF ISNULL(@DateMove,1)=1 SELECT @DateMove=CURRENT_TIMESTAMP
BEGIN TRAN
 /*     */
 UPDATE PerUser 
  SET LastOwner=0
  WHERE IDhard=@IDhard
   AND LastOwner=1

 /*    */
 INSERT INTO PerUser (IDhard,IDuser,DateMove,LastOwner)
  VALUES (@IDhard,@IDuser,@DateMove,1)
COMMIT TRAN
go

CREATE PROCEDURE SearchLNComputer 
 @LabelNo LABELNO
 AS
/* ---------------------------------- */
/*      */
/* ---------------------------------- */
BEGIN
 SELECT CP.LabelNo,CP.IDcomp,CP.IDmark,FL.Mark,FL.Type,FL.IDtype
  FROM Computer CP,vwFullCMarkList FL
  WHERE CP.LabelNo=@LabelNo
   AND FL.IDmark=CP.IDmark
END
go

CREATE PROCEDURE SearchLNPeripheral
 @LabelNo LABELNO
 AS
/* ---------------------------------- */
/*      */
/* ---------------------------------- */
BEGIN
 SELECT PR.LabelNo,PR.IDhard,PR.IDmark,FL.Mark,FL.Type,FL.IDtype
  FROM Peripheral PR,vwFullPMarkList FL
  WHERE PR.LabelNo=@LabelNo
   AND FL.IDmark=PR.IDmark
END
go

CREATE PROCEDURE SearchMACComputer 
 @MACadress VARCHAR(20)
 AS
/* ------------------------------ */
/*    MAC  */
/* ------------------------------ */
BEGIN
 DECLARE @IDcomp IDCOMP
 SELECT @IDcomp=IDcomp 
  FROM InternalDevice 
  WHERE ExtData=@MACadress
 
 SELECT CP.IDcomp,CP.IDmark,FL.Mark,FL.Type,FL.IDtype
  FROM Computer CP,vwFullCMarkList FL
  WHERE CP.IDcomp=@IDcomp
   AND FL.IDmark=CP.IDmark
END
go

CREATE PROCEDURE SearchNewUser 
 @UserName VARCHAR(50) 
 AS
/* ------------------------------- */
/*      PersonDB */
/* ------------------------------- */
BEGIN
 SELECT Person,Depart 
  FROM PersonDB.dbo.Users
  WHERE Person LIKE @UserName+'%'
END
go

CREATE PROCEDURE SearchSNComputer 
 @SerialNo SERIALNO
 AS
/* ------------------------------------ */
/*      */
/* ------------------------------------ */
BEGIN
 SELECT CP.SerialNo,CP.IDcomp,CP.IDmark,FL.Mark,FL.Type,FL.IDtype
  FROM Computer CP,vwFullCMarkList FL
  WHERE CP.SerialNo=@SerialNo
   AND FL.IDmark=CP.IDmark
END
go

CREATE PROCEDURE SearchSNPeripheral
 @SerialNo SERIALNO
 AS
/* ------------------------------------ */
/*      */
/* ------------------------------------ */
BEGIN
 SELECT PR.SerialNo,PR.IDhard,PR.IDmark,FL.Mark,FL.Type,FL.IDtype
  FROM Peripheral PR,vwFullPMarkList FL
  WHERE PR.SerialNo=@SerialNo
   AND FL.IDmark=PR.IDmark
END
go

CREATE PROCEDURE SearchUser 
 @UserName VARCHAR(50) 
 AS
/* -------------------------------- */
/*      Computers */
/* -------------------------------- */
BEGIN
 SELECT UL.IDuser,UL.Name,DP.Name AS Depart,DP.IDdepart
  FROM UserList UL,Department DP
  WHERE UL.Name LIKE @UserName+'%'
   AND DP.IDdepart=UL.IDdepart
END
go

CREATE PROCEDURE StatCAll 
 AS
/* ----------------------- */
/*    */
/* ----------------------- */
BEGIN
 SELECT COUNT(CP.IDmark) AS Cnt,CM.IDtype,CT.Name
  FROM Computer CP,ComputerMark CM,ComputerType CT
  WHERE CP.IDmark=*CM.IDmark
   AND CT.IDtype=CM.IDtype
  GROUP BY CM.IDtype,CT.Name
  ORDER BY 1 DESC,3
END
go

CREATE PROCEDURE StatCAllDepart 
 AS
/* ---------------------------------------------- */
/*      */
/* ---------------------------------------------- */
BEGIN
 SELECT COUNT(CS.IDdepart) AS Cnt,DP.IDdepart,DP.name
  FROM vwCompStat CS,Department DP 
  WHERE CS.IDdepart=DP.IDdepart 
  GROUP BY DP.IDdepart,DP.Name
  ORDER BY 1 DESC,3
END
go

CREATE PROCEDURE StatCAllSupp
 AS
/* ------------------------------------------- */
/*      */
/* ------------------------------------------- */
BEGIN
 SELECT COUNT(CS.IDsupplier) AS Cnt,SP.IDsupplier,SP.Name
  FROM vwCompStat CS,Supplier SP
  WHERE CS.IDsupplier=SP.IDsupplier
  GROUP BY SP.IDsupplier,SP.Name
  ORDER BY 1 DESC ,3
END
go

CREATE PROCEDURE StatCDepartment 
 @IDdepart IDDEPART
 AS
/* -------------------------------------------- */
/*      */
/* -------------------------------------------- */
BEGIN
 SELECT COUNT(CP.IDmark) AS Cnt,CM.IDtype,CT.Name
  FROM Computer CP,ComputerMark CM,ComputerType CT,CompUser CU
  WHERE CU.IDuser IN (SELECT IDuser FROM UserList WHERE IDdepart=@IDdepart)
   AND CU.LastOwner=1
   AND CP.IDcomp=CU.IDcomp
   AND CP.IDmark=CM.IDmark
   AND CT.IDtype=CM.IDtype
  GROUP BY CM.IDtype,CT.Name
  ORDER BY 1 DESC,3
END
go

CREATE PROCEDURE StatCSupplier 
 @IDsupplier IDSUPPLIER
 AS
/* ----------------------------------------- */
/*      */
/* ----------------------------------------- */
BEGIN
 SELECT COUNT(CP.IDmark) AS Cnt,CM.IDtype,CT.Name
  FROM Computer CP,ComputerMark CM,ComputerType CT
  WHERE CP.IDsupplier=@IDsupplier 
   AND CP.IDmark=CM.IDmark
   AND CT.IDtype=CM.IDtype
  GROUP BY CM.IDtype,CT.Name
  ORDER BY 1 DESC,3
END
go

CREATE PROCEDURE StatCType 
 @IDtype IDTYPE
 AS
/* ---------------------------------------- */
/*      */
/*         */
/* ---------------------------------------- */
BEGIN
 SELECT COUNT(CP.IDmark) AS Cnt,CP.IDmark,CM.Name 
  FROM ComputerMark CM,Computer CP
  WHERE CM.IDtype=@IDtype
   AND CM.IDmark=CP.IDmark
  GROUP BY CP.IDmark,CM.Name
  ORDER BY 1 DESC,3
END
go

CREATE PROCEDURE StatDUsers 
 AS
/* ---------------------------------------- */
/*     */
/* ---------------------------------------- */
BEGIN
 SELECT COUNT(UL.IDuser) AS Cnt,DP.IDdepart,DP.Name
  FROM UserList UL,Department DP
  WHERE UL.IDdepart=*DP.IDdepart
  GROUP BY DP.Name,DP.IDdepart
  ORDER BY 1 DESC,3

END
go

CREATE PROCEDURE StatPAll 
 AS
/* --------------------- */
/*    */
/* --------------------- */
BEGIN
 SELECT COUNT(PR.IDmark) AS Cnt,DM.IDtype,DT.Name
  FROM Peripheral PR,DeviceMark DM,DeviceType DT
  WHERE PR.IDmark=*DM.IDmark
   AND DT.IDtype=DM.IDtype
   AND DT.External=1
  GROUP BY DM.IDtype,DT.Name
  ORDER BY 1 DESC,3
END
go

CREATE PROCEDURE StatPAllDepart
 @IDtype IDTYPE
 AS
/* ------------------------------------------ */
/*      */
/*                            */
/* ------------------------------------------ */
BEGIN
 SELECT COUNT(PS.IDdepart) AS Cnt,DP.IDdepart,DP.name
  FROM vwPerStat PS,Department DP 
  WHERE PS.IDdepart=DP.IDdepart
   AND PS.IDtype=@IDtype
  GROUP BY DP.IDdepart,DP.Name
  ORDER BY 1 DESC,3
END
go

CREATE PROCEDURE StatPAllSupp
 @IDtype IDTYPE
 AS
/* ------------------------------------------ */
/*      */
/*                               */
/* ------------------------------------------ */
BEGIN
 SELECT COUNT(PS.IDsupplier) AS Cnt,SP.IDsupplier,SP.Name
  FROM vwPerStat PS,Supplier SP
  WHERE PS.IDsupplier=SP.IDsupplier
   AND PS.IDtype=@IDtype
  GROUP BY SP.IDsupplier,SP.Name
  ORDER BY 1 DESC,3
END
go

CREATE PROCEDURE StatPDepartment 
 @IDdepart IDDEPART
 AS
/* -------------------------------------------- */
/*        */
/* -------------------------------------------- */
BEGIN
 SELECT COUNT(PR.IDmark) AS Cnt,DM.IDtype,DT.Name
  FROM Peripheral PR,DeviceMark DM,DeviceType DT,PerUser PU
  WHERE PU.IDuser IN (SELECT IDuser FROM UserList WHERE IDdepart=@IDdepart)
   AND PU.LastOwner=1
   AND PR.IDhard=PU.IDhard
   AND PR.IDmark=DM.IDmark
   AND DT.IDtype=DM.IDtype
  GROUP BY DM.IDtype,DT.Name
  ORDER BY 1 DESC,3
END
go

CREATE PROCEDURE StatPSupplier 
 @IDsupplier IDSUPPLIER
 AS
/* ----------------------------------------- */
/*      */
/* ----------------------------------------- */
BEGIN
 SELECT COUNT(PR.IDmark) AS Cnt,DM.IDtype,DT.Name
  FROM Peripheral PR,DeviceMark DM,DeviceType DT
  WHERE PR.IDsupplier=@IDsupplier 
   AND PR.IDmark=DM.IDmark
   AND DT.IDtype=DM.IDtype
  GROUP BY DM.IDtype,DT.Name
  ORDER BY 1 DESC,3
END
go

CREATE PROCEDURE StatPType 
 @IDtype IDTYPE
 AS
/* ---------------------------------------- */
/*        */
/*         */
/* ---------------------------------------- */
DECLARE @External BINARY(1)
BEGIN
 /*    */
 SELECT @External=External 
  FROM DeviceType 
  WHERE IDtype=@IDtype

 IF @External=1
  /*  */
  SELECT COUNT(PR.IDmark) AS Cnt,PR.IDmark,DM.Name 
   FROM DeviceMark DM,Peripheral PR
   WHERE DM.IDtype=@IDtype
    AND DM.IDmark=PR.IDmark
   GROUP BY PR.IDmark,DM.name
   ORDER BY 1 DESC,3
 ELSE
  /*   */
  SELECT COUNT(ID.IDmark) AS Cnt,ID.IDmark,DM.Name 
   FROM DeviceMark DM,InternalDevice ID
   WHERE DM.IDtype=@IDtype
    AND DM.IDmark=ID.IDmark
   GROUP BY ID.IDmark,DM.Name
   ORDER BY 1 DESC,3
END
go

CREATE PROCEDURE UpdateCMark 
 @IDmark IDMARK,
 @Name NAME,
 @IDtype IDTYPE
 AS
/* ----------------------------- */
/*      */
/*    */
/* ----------------------------- */
BEGIN
 IF EXISTS(SELECT IDmark FROM ComputerMark WHERE IDmark=@IDmark AND NoDelete=1)
  RAISERROR 99999 '   '

 ELSE
 BEGIN
  /*   */
  UPDATE ComputerMark 
   SET Name=@Name,IDtype=@IDtype
   WHERE IDmark=@IDmark

  /*   */
  SELECT * FROM ComputerMark WHERE IDmark=@IDmark
 END
END
go

CREATE PROCEDURE UpdateCOwDate 
 @IDcomp  IDCOMP,
 @DateMove DATETIME=NULL
 AS
/* ---------------------------------------------------- */
/*     ""        */
/* ---------------------------------------------------- */

BEGIN
 DECLARE @OldDate DATETIME
 SELECT @OldDate=DateMove FROM CompUser WHERE IDcomp=@IDcomp AND LastOwner=1

 IF ISNULL(@DateMove,1)=1 
  SET @DateMove=CURRENT_TIMESTAMP

 IF @OldDate<> @DateMove 
  UPDATE CompUser 
   SET DateMove=@DateMove
   WHERE IDcomp=@IDcomp 
    AND LastOwner=1
END
go

CREATE PROCEDURE UpdateCType 
 @IDtype IDTYPE,
 @Name NAME
 AS
/* --------------------------------------- */
/*     */
/*              */
/* --------------------------------------- */
BEGIN
 /*    */
 IF EXISTS(SELECT IDtype FROM ComputerType WHERE IDtype=@IDtype AND NoDelete=1)
  RAISERROR 99999 '   '
 ELSE
 BEGIN
  /*  */
  UPDATE ComputerType
   SET Name=@Name
   WHERE IDtype=@IDtype
  /*   */ 
  SELECT * FROM ComputerType WHERE IDtype=@IDtype
 END
END
go

CREATE PROCEDURE UpdateComputer 
 @IDcomp  IDCOMP,
 @IDsupplier IDSUPPLIER,
 @WarrMonth TINYINT,
 @WarrDoc WARRDOC,
 @Invoice INVOICE,
 @PayOrder PAYORDER,
 @WayBill WAYBILL,
 @InvOrder INVORDER,
 @Definition DEFINITION
AS
/* ------------------------------ */
/*    */
/* ------------------------------ */
BEGIN
 /*   */
 UPDATE Computer 
  SET IDsupplier=@IDsupplier,WarrMonth=@WarrMonth,WarrDoc=@WarrDoc,Invoice=@Invoice,PayOrder=@PayOrder,WayBill=@WayBill,InvOrder=@InvOrder,Definition=@Definition
  WHERE IDcomp=@IDcomp

 /*    */
 SELECT * FROM Computer WHERE IDcomp=@IDcomp
END
go

CREATE PROCEDURE UpdateDepartment
 @IDdepart IDDEPART,
 @Name  NAME
 AS
/* --------------------------------------- */
/*      */
/*              */
/* --------------------------------------- */
BEGIN
 /*    */
 IF EXISTS(SELECT IDdepart FROM Department WHERE IDdepart=@IDdepart AND NoDelete=1)
  RAISERROR 99999 '   '
 ELSE
 BEGIN
  /*  */
  UPDATE Department
   SET Name=@Name
   WHERE IDdepart=@IDdepart
  /*   */ 
  SELECT * FROM Department WHERE IDdepart=@IDdepart
 END
END
go

CREATE PROCEDURE UpdateIDevice 
 @IDcomp  IDCOMP,
 @IDhard  IDHARD,
 @Note  NOTE,
 @ExtData VARCHAR(20)
 AS
/* ---------------------------- */
/*    */
/* ---------------------------- */
BEGIN
 /*   */
 UPDATE InternalDevice
  SET Note=@Note,Extdata=@Extdata
  WHERE IDcomp=@IDcomp
   AND IDhard=@IDhard

 /*    */
 SELECT * FROM InternalDevice WHERE IDcomp=@IDcomp AND IDhard=@IDhard
 
END
go

CREATE PROCEDURE UpdatePMark 
 @IDmark IDMARK,
 @Name NAME,
 @IDtype IDTYPE
 AS
/* ----------------------------- */
/*      */
/*    */
/* ----------------------------- */
BEGIN
 IF EXISTS(SELECT IDmark FROM DeviceMark WHERE IDmark=@IDmark AND NoDelete=1)
  RAISERROR 99999 '   '

 ELSE
 BEGIN
  /*   */
  UPDATE DeviceMark 
   SET Name=@Name,IDtype=@IDtype
   WHERE IDmark=@IDmark

  /*   */
  SELECT * FROM DeviceMark WHERE IDmark=@IDmark
 END
END
go

CREATE PROCEDURE UpdatePOwDate 
 @IDhard  IDHARD,
 @DateMove DATETIME=NULL
 AS
/* ---------------------------------------------------- */
/*     ""        */
/* ---------------------------------------------------- */

BEGIN
 DECLARE @OldDate DATETIME
 SELECT @OldDate=DateMove FROM PerUser WHERE IDhard=@IDhard AND LastOwner=1

 IF ISNULL(@DateMove,1)=1 
  SET @DateMove=CURRENT_TIMESTAMP

 IF @OldDate<> @DateMove 
  UPDATE PerUser
   SET DateMove=@DateMove
   WHERE IDhard=@IDhard 
    AND LastOwner=1
END
go

CREATE PROCEDURE UpdatePType
 @IDtype  IDTYPE,
 @Name  NAME,
 @External EXTERNAL,
 @ExtDataHead VARCHAR(20)=''
 AS
/* --------------------------------- */
/*      */
/*        */
/* --------------------------------- */
BEGIN
 IF EXISTS(SELECT IDtype FROM DeviceType WHERE IDtype=@IDtype AND NoDelete=1)
  RAISERROR 99999 '   '
 ELSE
 BEGIN
  /*   */
  UPDATE DeviceType 
   SET Name=@Name,External=@External,ExtdataHead=@ExtDataHead
   WHERE IDtype=@IDtype
 
  /*   */ 
  SELECT * FROM DeviceType WHERE IDtype=@IDtype
 END
END
go

CREATE PROCEDURE UpdatePeripheral 
 @IDhard  IDHARD,
 @IDsupplier IDSUPPLIER,
 @WarrMonth TINYINT,
 @WarrDoc WARRDOC,
 @Invoice INVOICE,
 @PayOrder PAYORDER,
 @WayBill WAYBILL,
 @InvOrder INVORDER,
 @ExtData VARCHAR(20),
 @Definition DEFINITION
AS
/* ------------------------------ */
/*    */
/* ------------------------------ */
BEGIN
 /*   */
 UPDATE Peripheral
  SET IDsupplier=@IDsupplier,WarrMonth=@WarrMonth,WarrDoc=@WarrDoc,Invoice=@Invoice,PayOrder=@PayOrder,WayBill=@WayBill,InvOrder=@InvOrder,Definition=@Definition,ExtData=@ExtData
  WHERE IDhard=@IDhard

 /*    */
 SELECT * FROM Peripheral WHERE IDhard=@IDhard
END
go

CREATE PROCEDURE UpdateSupplier 
 @IDsupplier IDSUPPLIER,
 @Name  NAME,
 @Adress  ADRESS,
 @Bank  BANK,
 @Phone  PHONE,
 @Fax  FAX,
 @E_mail  EMAIL,
 @WWWadress WWWadress,
 @ContactPerson CONTACTPERSON,
 @ContactPhone PHONE,
 @Note  NOTE
 AS
/* ------------------------------ */
/*     */
/* ------------------------------ */
BEGIN
 IF EXISTS(SELECT IDsupplier FROM Supplier WHERE IDsupplier=@IDsupplier AND NoDelete=1)
  RAISERROR 99999 '   '
 ELSE
 BEGIN
  /*   */
  UPDATE Supplier 
   SET Name=@Name,Adress=@Adress,Bank=@Bank,Phone=@Phone,Fax=@Fax,E_mail=@E_mail,
    WWWadress=@WWWadress,ContactPerson=@ContactPerson,Note=@Note,ContactPhone=@ContactPhone
   WHERE IDsupplier=@IDsupplier

  /*    */
  SELECT * FROM Supplier WHERE IDsupplier=@IDsupplier
 END
END
go

CREATE PROCEDURE UpdateUser 
 @IDuser  IDUSER,
 @Name  NAME,
 @NoRoom  SMALLINT,
 @IDdepart IDDEPART
 AS
/* ------------------------------ */
/*    */
/* ------------------------------ */
BEGIN
 IF EXISTS(SELECT IDuser FROM UserList WHERE IDuser=@IDuser AND NoDelete=1)
  RAISERROR 99999 '   '
 ELSE
 BEGIN
  /*  */
  UPDATE UserList
   SET Name=@Name, NoRoom=@NoRoom, IDdepart=@IDdepart
   WHERE IDuser=@IDuser

  /*   */
  SELECT * FROM UserList WHERE IDuser=@IDuser
 END
END
go



create trigger tI_CompNotes on CompNotes
  for INSERT
  as
/* ERwin Builtin Fri Jun 22 15:29:15 2001 */
/* INSERT trigger on CompNotes */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount
  /* ERwin Builtin Fri Jun 22 15:29:15 2001 */
  /* Computer  CompNotes ON CHILD INSERT RESTRICT */
  if
    /* ChildFK(" or",update) */
    update(IDcomp)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,Computer
        where
          /* JoinFKPK */
          inserted.IDcomp = Computer.IDcomp
    /* NotnullFK */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = 'Cannot INSERT CompNotes because Computer does not exist.'
      goto error
    end
  end


  /* ERwin Builtin Fri Jun 22 15:29:15 2001 */
  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go


create trigger tU_CompNotes on CompNotes
  for UPDATE
  as
/* ERwin Builtin Fri Jun 22 15:29:15 2001 */
/* UPDATE trigger on CompNotes */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @insIDcomp int, 
           @insDateNote datetime,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount
  /* ERwin Builtin Fri Jun 22 15:29:15 2001 */
  /* Computer  CompNotes ON CHILD UPDATE RESTRICT */
  if
    /* ChildFK(" or",update) */
    update(IDcomp)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,Computer
        where
          /* JoinFKPK */
          inserted.IDcomp = Computer.IDcomp
    /* NotnullFK */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = 'Cannot UPDATE CompNotes because Computer does not exist.'
      goto error
    end
  end


  /* ERwin Builtin Fri Jun 22 15:29:15 2001 */
  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go


create trigger tI_CompUser on CompUser
  for INSERT
  as
/* ERwin Builtin Mon Jun 18 13:39:08 2001 */
/* INSERT trigger on CompUser */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount
  /* ERwin Builtin Mon Jun 18 13:39:08 2001 */
  /* UserList R/18 CompUser ON CHILD INSERT RESTRICT */
  if
    /* ChildFK(" or",update) */
    update(IDuser)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,UserList
        where
          /* JoinFKPK */
          inserted.IDuser = UserList.IDuser
    /* NotnullFK */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = 'Cannot INSERT CompUser because UserList does not exist.'
      goto error
    end
  end

  /* ERwin Builtin Mon Jun 18 13:39:08 2001 */
  /* Computer R/17 CompUser ON CHILD INSERT RESTRICT */
  if
    /* ChildFK(" or",update) */
    update(IDcomp)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,Computer
        where
          /* JoinFKPK */
          inserted.IDcomp = Computer.IDcomp
    /* NotnullFK */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = 'Cannot INSERT CompUser because Computer does not exist.'
      goto error
    end
  end


  /* ERwin Builtin Mon Jun 18 13:39:08 2001 */
  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go


create trigger tU_CompUser on CompUser
  for UPDATE
  as
/* ERwin Builtin Mon Jun 18 13:39:08 2001 */
/* UPDATE trigger on CompUser */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @insIDcomp int, 
           @insIDuser int,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount
  /* ERwin Builtin Mon Jun 18 13:39:08 2001 */
  /* UserList R/18 CompUser ON CHILD UPDATE RESTRICT */
  if
    /* ChildFK(" or",update) */
    update(IDuser)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,UserList
        where
          /* JoinFKPK */
          inserted.IDuser = UserList.IDuser
    /* NotnullFK */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = 'Cannot UPDATE CompUser because UserList does not exist.'
      goto error
    end
  end

  /* ERwin Builtin Mon Jun 18 13:39:08 2001 */
  /* Computer R/17 CompUser ON CHILD UPDATE RESTRICT */
  if
    /* ChildFK(" or",update) */
    update(IDcomp)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,Computer
        where
          /* JoinFKPK */
          inserted.IDcomp = Computer.IDcomp
    /* NotnullFK */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = 'Cannot UPDATE CompUser because Computer does not exist.'
      goto error
    end
  end


  /* ERwin Builtin Mon Jun 18 13:39:08 2001 */
  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go


create trigger TD_CM_NoDelete on ComputerMark
  for UPDATE
  as
/* ERwin Builtin Mon Jun 03 11:19:47 2002 */
/* UPDATE trigger on ComputerMark */
/* default body for TD_CM_NoDelete */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @insIDmark IDmark,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount

if exists (select * from deleted where NoDelete=1)
begin
  select @errno=50001,@errmsg='Cannot DELETE the system records'
  goto error
end


/* ERwin Builtin Mon Jun 03 11:19:47 2002 */
  /* ComputerMark  Computer ON PARENT UPDATE RESTRICT */
  if
    /* update(IDmark) */
    update(IDmark)
  begin
    if exists (
      select * from deleted,Computer
      where
        /*  Computer.IDmark = deleted.IDmark */
        Computer.IDmark = deleted.IDmark
    )
    begin
      select @errno  = 30005,
             @errmsg = 'Cannot UPDATE ComputerMark because Computer exists.'
      goto error
    end
  end


  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go




create trigger TD_CT_NoDelete on ComputerType
  for DELETE
  as
/* ERwin Builtin Mon Jun 03 11:19:47 2002 */
/* DELETE trigger on ComputerType */
/* default body for TD_CT_NoDelete */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @insIDtype IDtype,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount

if exists (select * from deleted where NoDelete=1)
begin
  select @errno=50001,@errmsg='Cannot DELETE the system records'
  goto error
end


/* ERwin Builtin Mon Jun 03 11:19:47 2002 */
    /* ComputerType  ComputerMark ON PARENT DELETE RESTRICT */
    if exists (
      select * from deleted,ComputerMark
      where
        /*  ComputerMark.IDtype = deleted.IDtype */
        ComputerMark.IDtype = deleted.IDtype
    )
    begin
      select @errno  = 30001,
             @errmsg = 'Cannot DELETE ComputerType because ComputerMark exists.'
      goto error
    end


  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go








create trigger TD_DP_NoDelete on Department
  for DELETE
  as
/* ERwin Builtin Mon Jun 03 11:19:47 2002 */
/* DELETE trigger on Department */
/* default body for TD_DP_NoDelete */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @insIDdepart IDdepart,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount

if exists (select * from deleted where NoDelete=1)
begin
  select @errno=50001,@errmsg='Cannot DELETE the system records'
  goto error
end


/* ERwin Builtin Mon Jun 03 11:19:47 2002 */
    /* Department  UserList ON PARENT DELETE RESTRICT */
    if exists (
      select * from deleted,UserList
      where
        /*  UserList.IDdepart = deleted.IDdepart */
        UserList.IDdepart = deleted.IDdepart
    )
    begin
      select @errno  = 30001,
             @errmsg = 'Cannot DELETE Department because UserList exists.'
      goto error
    end


  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go




create trigger TD_DM_NoDelete on DeviceMark
  for DELETE
  as
/* ERwin Builtin Mon Jun 03 11:19:47 2002 */
/* DELETE trigger on DeviceMark */
/* default body for TD_DM_NoDelete */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @insIDmark IDmark,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount

if exists (select * from deleted where NoDelete=1)
begin
  select @errno=50001,@errmsg='Cannot DELETE the system records'
  goto error
end


/* ERwin Builtin Mon Jun 03 11:19:47 2002 */
    /* DeviceMark  Peripheral ON PARENT DELETE RESTRICT */
    if exists (
      select * from deleted,Peripheral
      where
        /*  Peripheral.IDmark = deleted.IDmark */
        Peripheral.IDmark = deleted.IDmark
    )
    begin
      select @errno  = 30001,
             @errmsg = 'Cannot DELETE DeviceMark because Peripheral exists.'
      goto error
    end

/* ERwin Builtin Mon Jun 03 11:19:47 2002 */
    /* DeviceMark   InternalDevice ON PARENT DELETE RESTRICT */
    if exists (
      select * from deleted,InternalDevice
      where
        /*  InternalDevice.IDmark = deleted.IDmark */
        InternalDevice.IDmark = deleted.IDmark
    )
    begin
      select @errno  = 30001,
             @errmsg = 'Cannot DELETE DeviceMark because InternalDevice exists.'
      goto error
    end


  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go




create trigger TD_DT_NoDelete on DeviceType
  for DELETE
  as
/* ERwin Builtin Mon Jun 03 11:19:47 2002 */
/* DELETE trigger on DeviceType */
/* default body for TD_DT_NoDelete */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @insIDtype IDtype,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount

if exists (select * from deleted where NoDelete=1)
begin
  select @errno=50001,@errmsg='Cannot DELETE the system records'
  goto error
end


/* ERwin Builtin Mon Jun 03 11:19:47 2002 */
    /* DeviceType  DeviceMark ON PARENT DELETE RESTRICT */
    if exists (
      select * from deleted,DeviceMark
      where
        /*  DeviceMark.IDtype = deleted.IDtype */
        DeviceMark.IDtype = deleted.IDtype
    )
    begin
      select @errno  = 30001,
             @errmsg = 'Cannot DELETE DeviceType because DeviceMark exists.'
      goto error
    end


  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go




create trigger tI_InternalDevice on InternalDevice
  for INSERT
  as
/* ERwin Builtin Fri Jun 22 15:29:16 2001 */
/* INSERT trigger on InternalDevice */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount
  /* ERwin Builtin Fri Jun 22 15:29:16 2001 */
  /* DeviceMark   InternalDevice ON CHILD INSERT RESTRICT */
  if
    /* ChildFK(" or",update) */
    update(IDmark)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,DeviceMark
        where
          /* JoinFKPK */
          inserted.IDmark = DeviceMark.IDmark
    /* NotnullFK */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = 'Cannot INSERT InternalDevice because DeviceMark does not exist.'
      goto error
    end
  end

  /* ERwin Builtin Fri Jun 22 15:29:16 2001 */
  /* Computer  InternalDevice ON CHILD INSERT RESTRICT */
  if
    /* ChildFK(" or",update) */
    update(IDcomp)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,Computer
        where
          /* JoinFKPK */
          inserted.IDcomp = Computer.IDcomp
    /* NotnullFK */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = 'Cannot INSERT InternalDevice because Computer does not exist.'
      goto error
    end
  end


  /* ERwin Builtin Fri Jun 22 15:29:16 2001 */
  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go


create trigger tU_InternalDevice on InternalDevice
  for UPDATE
  as
/* ERwin Builtin Fri Jun 22 15:29:16 2001 */
/* UPDATE trigger on InternalDevice */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @insIDcomp int, 
           @insIDhard IDhard,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount
  /* ERwin Builtin Fri Jun 22 15:29:16 2001 */
  /* DeviceMark   InternalDevice ON CHILD UPDATE RESTRICT */
  if
    /* ChildFK(" or",update) */
    update(IDmark)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,DeviceMark
        where
          /* JoinFKPK */
          inserted.IDmark = DeviceMark.IDmark
    /* NotnullFK */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = 'Cannot UPDATE InternalDevice because DeviceMark does not exist.'
      goto error
    end
  end

  /* ERwin Builtin Fri Jun 22 15:29:16 2001 */
  /* Computer  InternalDevice ON CHILD UPDATE RESTRICT */
  if
    /* ChildFK(" or",update) */
    update(IDcomp)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,Computer
        where
          /* JoinFKPK */
          inserted.IDcomp = Computer.IDcomp
    /* NotnullFK */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = 'Cannot UPDATE InternalDevice because Computer does not exist.'
      goto error
    end
  end


  /* ERwin Builtin Fri Jun 22 15:29:16 2001 */
  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go


create trigger tI_PerNotes on PerNotes
  for INSERT
  as
/* ERwin Builtin Fri Jun 22 15:29:16 2001 */
/* INSERT trigger on PerNotes */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount
  /* ERwin Builtin Fri Jun 22 15:29:16 2001 */
  /* Peripheral  PerNotes ON CHILD INSERT RESTRICT */
  if
    /* ChildFK(" or",update) */
    update(IDhard)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,Peripheral
        where
          /* JoinFKPK */
          inserted.IDhard = Peripheral.IDhard
    /* NotnullFK */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = 'Cannot INSERT PerNotes because Peripheral does not exist.'
      goto error
    end
  end


  /* ERwin Builtin Fri Jun 22 15:29:16 2001 */
  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go


create trigger tU_PerNotes on PerNotes
  for UPDATE
  as
/* ERwin Builtin Fri Jun 22 15:29:16 2001 */
/* UPDATE trigger on PerNotes */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @insIDhard int, 
           @insDateNote datetime,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount
  /* ERwin Builtin Fri Jun 22 15:29:16 2001 */
  /* Peripheral  PerNotes ON CHILD UPDATE RESTRICT */
  if
    /* ChildFK(" or",update) */
    update(IDhard)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,Peripheral
        where
          /* JoinFKPK */
          inserted.IDhard = Peripheral.IDhard
    /* NotnullFK */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = 'Cannot UPDATE PerNotes because Peripheral does not exist.'
      goto error
    end
  end


  /* ERwin Builtin Fri Jun 22 15:29:16 2001 */
  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go


create trigger tI_PerUser on PerUser
  for INSERT
  as
/* ERwin Builtin Mon Jun 18 13:39:08 2001 */
/* INSERT trigger on PerUser */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount
  /* ERwin Builtin Mon Jun 18 13:39:08 2001 */
  /* UserList R/23 PerUser ON CHILD INSERT RESTRICT */
  if
    /* ChildFK(" or",update) */
    update(IDuser)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,UserList
        where
          /* JoinFKPK */
          inserted.IDuser = UserList.IDuser
    /* NotnullFK */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = 'Cannot INSERT PerUser because UserList does not exist.'
      goto error
    end
  end

  /* ERwin Builtin Mon Jun 18 13:39:08 2001 */
  /* Peripheral R/22 PerUser ON CHILD INSERT RESTRICT */
  if
    /* ChildFK(" or",update) */
    update(IDhard)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,Peripheral
        where
          /* JoinFKPK */
          inserted.IDhard = Peripheral.IDhard
    /* NotnullFK */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = 'Cannot INSERT PerUser because Peripheral does not exist.'
      goto error
    end
  end


  /* ERwin Builtin Mon Jun 18 13:39:08 2001 */
  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go


create trigger tU_PerUser on PerUser
  for UPDATE
  as
/* ERwin Builtin Mon Jun 18 13:39:08 2001 */
/* UPDATE trigger on PerUser */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @insIDhard int, 
           @insIDuser int,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount
  /* ERwin Builtin Mon Jun 18 13:39:08 2001 */
  /* UserList R/23 PerUser ON CHILD UPDATE RESTRICT */
  if
    /* ChildFK(" or",update) */
    update(IDuser)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,UserList
        where
          /* JoinFKPK */
          inserted.IDuser = UserList.IDuser
    /* NotnullFK */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = 'Cannot UPDATE PerUser because UserList does not exist.'
      goto error
    end
  end

  /* ERwin Builtin Mon Jun 18 13:39:08 2001 */
  /* Peripheral R/22 PerUser ON CHILD UPDATE RESTRICT */
  if
    /* ChildFK(" or",update) */
    update(IDhard)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,Peripheral
        where
          /* JoinFKPK */
          inserted.IDhard = Peripheral.IDhard
    /* NotnullFK */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = 'Cannot UPDATE PerUser because Peripheral does not exist.'
      goto error
    end
  end


  /* ERwin Builtin Mon Jun 18 13:39:08 2001 */
  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go


create trigger TD_SP_NoDelete on Supplier
  for DELETE
  as
/* ERwin Builtin Mon Jun 03 11:19:47 2002 */
/* DELETE trigger on Supplier */
/* default body for TD_SP_NoDelete */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @insIDsupplier IDsupplier,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount

if exists (select * from deleted where NoDelete=1)
begin
  select @errno=50001,@errmsg='Cannot DELETE the system records'
  goto error
end


/* ERwin Builtin Mon Jun 03 11:19:47 2002 */
    /* Supplier  Peripheral ON PARENT DELETE RESTRICT */
    if exists (
      select * from deleted,Peripheral
      where
        /*  Peripheral.IDsupplier = deleted.IDsupplier */
        Peripheral.IDsupplier = deleted.IDsupplier
    )
    begin
      select @errno  = 30001,
             @errmsg = 'Cannot DELETE Supplier because Peripheral exists.'
      goto error
    end

/* ERwin Builtin Mon Jun 03 11:19:47 2002 */
    /* Supplier  Computer ON PARENT DELETE RESTRICT */
    if exists (
      select * from deleted,Computer
      where
        /*  Computer.IDsupplier = deleted.IDsupplier */
        Computer.IDsupplier = deleted.IDsupplier
    )
    begin
      select @errno  = 30001,
             @errmsg = 'Cannot DELETE Supplier because Computer exists.'
      goto error
    end


  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go




create trigger TD_UL_NoDelete on UserList
  for DELETE
  as
/* ERwin Builtin Mon Jun 03 11:19:47 2002 */
/* DELETE trigger on UserList */
/* default body for TD_UL_NoDelete */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @insIDuser IDuser,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount

if exists (select * from deleted where NoDelete=1)
begin
  select @errno=50001,@errmsg='Cannot DELETE the system records'
  goto error
end


/* ERwin Builtin Mon Jun 03 11:19:47 2002 */
    /* UserList R/23 PerUser ON PARENT DELETE RESTRICT */
    if exists (
      select * from deleted,PerUser
      where
        /*  PerUser.IDuser = deleted.IDuser */
        PerUser.IDuser = deleted.IDuser
    )
    begin
      select @errno  = 30001,
             @errmsg = 'Cannot DELETE UserList because PerUser exists.'
      goto error
    end

/* ERwin Builtin Mon Jun 03 11:19:47 2002 */
    /* UserList R/18 CompUser ON PARENT DELETE RESTRICT */
    if exists (
      select * from deleted,CompUser
      where
        /*  CompUser.IDuser = deleted.IDuser */
        CompUser.IDuser = deleted.IDuser
    )
    begin
      select @errno  = 30001,
             @errmsg = 'Cannot DELETE UserList because CompUser exists.'
      goto error
    end


  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go

EXEC CreateSystemRecords


