***************************************
*	Computers
*	 
***************************************

#INCLUDE "..\main.h"

* 
CLOSE ALL
CLEAR ALL
CLEAR

*  
SET TALK OFF
SET DELETE ON
SET CENTURY ON
SET SYSMENU OFF
SET DATE TO SHORT
IF FILE('COMPUTERS.HLP')
	SET HELP TO COMPUTERS.HLP
ELSE
	SET HELP OFF
ENDIF

ON SHUTDOWN DO StopApp

*  
PUBLIC goToolBar	&&  
PUBLIC goMsgBox		&&   
PUBLIC glToolBar	&&    
PUBLIC glStatusBar	&&    
PUBLIC gnConnect	&&   ODBC 
PUBLIC goIConfig	&&    
PUBLIC glExcel		&&   EXCEL
PUBLIC goStack		&&  

***    ***
SET CLASSLIB TO Interface	ADDITIVE
*SET CLASSLIB TO Dataclasses	ADDITIVE

*  
goMsgBox=CREATEOBJECT('cstMsgBox')
goToolBar=CREATEOBJECT('tbrStandard')
goIConfig=CREATEOBJECT('cstIConfig')
goStack=CREATEOBJECT('cstStack')

*   
ON ERROR glExcel=NO
glExcel=YES
oExcel=CREATEOBJ('Excel.Application')
ON ERROR
RELEASE oExcel

glToolBar=IIF(GetSysVal('TOOLBAR')='OFF',FALSE,TRUE)
glStatusBar=IIF(GetSysVal('STATUSBAR')='OFF',FALSE,TRUE)
IF EMPTY(GetSysVal('FIRMNAME'))
	PutSysVal('FIRMNAME','  VFP ')
ENDIF
_SCREEN.WindowState=2
_SCREEN.Visible=TRUE
_SCREEN.Icon='WINDOW.ICO'
_SCREEN.Caption='   '


HideSysTBR()
LoadMenu()
ShowTBR()
ShowSBR()
IF NOT DSNConnect()
	ON SHUTDOWN
	QUIT
ENDIF

*  
READ EVENTS
RETURN

***************************************
*	BeforeView
*	    
***************************************
FUNCTION BeforeView
	ON ERROR a=1
	SET MARK OF BAR 1 OF mnuView TO glToolBar
	SET MARK OF BAR 2 OF mnuView TO glStatusBar
	ON ERROR
ENDFUNC

***************************************
*	LoadMenu
*	 
***************************************
PROCEDURE LoadMenu
	SET SYSMENU OFF
	DO Computers.mpr
ENDPROC

***************************************
*	ShowTBR
*	  
***************************************
PROCEDURE ShowTBR
	IF TYPE('goToolBar')<>'O'
		RETURN
	ENDIF
	IF glToolBar
		goToolBar.Show()
		goToolBar.Refresh()
	ELSE
		goToolBar.Hide()
	ENDIF
ENDPROC

***************************************
*	ShowSBR
*	  
***************************************
PROCEDURE ShowSBR
	IF glStatusBar
		SET CLOCK STATUS
		SET STATUS BAR ON
	ELSE
		SET STATUS BAR OFF
	ENDIF
ENDPROC

***************************************
*	HideSysTBR
*	   
***************************************
PROCEDURE HideSysTBR
	PUBLIC aFoxToolBar
	DIMENSION aFoxToolBar(11,2)
	*    
	aFoxToolBar[ 1,1]	='Print Preview'
	aFoxToolBar[ 1,2]	=.F.
	aFoxToolBar[ 2,1]	='Database Designer'
	aFoxToolBar[ 2,2]	=.F.
	aFoxToolBar[ 3,1]	='Form Designer'
	aFoxToolBar[ 3,2]	=.F.
	aFoxToolBar[ 4,1]	='Report Controls'
	aFoxToolBar[ 4,2]	=.F.
	aFoxToolBar[ 5,1]	='Standard'
	aFoxToolBar[ 5,2]	=.F.
	aFoxToolBar[ 6,1]	='Query Designer'
	aFoxToolBar[ 6,2]	=.F.
	aFoxToolBar[ 7,1]	='Report Designer'
	aFoxToolBar[ 7,2]	=.F.
	aFoxToolBar[ 8,1]	='Layot'
	aFoxToolBar[ 8,2]	=.F.
	aFoxToolBar[ 9,1]	='View Designer'
	aFoxToolBar[ 9,2]	=.F.
	aFoxToolBar[10,1]	='Color Palette'
	aFoxToolBar[10,2]	=.F.
	aFoxToolBar[11,1]	='Form Controls'
	aFoxToolBar[11,2]	=.F.

	*   
	LOCAL i
	FOR i=1 TO 11
		aFoxToolBar(i,2)=WVISIBLE(aFoxToolBar(i,1))
		IF aFoxToolBar(i,2)
			HIDE WINDOW (aFoxToolBar(i,1))
		ENDIF
	NEXT
ENDPROC

***************************************
*	ShowSysTBR
*	  
***************************************
PROCEDURE ShowSysTBR
	LOCAL i
	FOR i=1 TO 11
		IF aFoxToolBar(i,2)
			SHOW WINDOW (aFoxToolBar(i,1))
		ENDIF
	NEXT
ENDPROC

***************************************
*	DSNconnect
*	  ODBC 
***************************************
FUNCTION DSNconnect
	LOCAL lcDSName
	lcDSName=GetSysVal('DSNAME')
	IF EMPTY(lcDSname)
		DO FORM GetDsn
		lcDSName=GetSysVal('DSNAME')
	ENDIF
	IF NOT EMPTY(lcDSname) THEN
		gnConnect=SQLconnect(lcDSName)
	ELSE
		goMsgBox.IBox('   !'+CHR(13)+'      DSN.')
		RETURN FALSE
	ENDIF
	IF gnConnect<1 OR SQLexec(gnConnect,"ChkConnect 'COMPUTERS'")<1
		goMsgBox.SBox(' !'+CHR(13)+'      DSN.')
		PutSysVal('DSNAME','')
		RETURN FALSE
	ELSE
		RETURN TRUE
	ENDIF
ENDFUNC

***************************************
*	CascadeRunForm
*	  .
***************************************
**	PARAMETERS:
**		1.    (Ch)
**		2. [ ] (U)
****************************************
PROCEDURE CascadeRunForm
PARAMETERS tcForm,tuVar
	PRIVATE pcNextForm
	pcNextForm=''
	IF PARAM()=1
		DO FORM (tcForm)
	ELSE
		DO FORM (tcForm) WITH tuVar
	ENDIF
	IF NOT EMPTY(pcNextForm)
		DO FORM (pcNextForm)
	ENDIF
ENDPROC

***************************************
*	StopApp
*	  
***************************************
PROCEDURE StopApp
	IF goMsgBox.QBox('  ?')=NO
		RETURN
	ENDIF
	*    
	LOCAL i,n
	n=_SCREEN.FormCount
	FOR i=1 TO n
		IF TYPE('_SCREEN.ActiveForm')='O' AND _SCREEN.ActiveForm.BaseClass='BASEFORM'
			_SCREEN.ActiveForm.FormAction(FA_CLOSE)
		ELSE
			IF TYPE('_SCREEN.ActiveForm')='O'
				_SCREEN.ActiveForm.Release()
			ENDIF
		ENDIF
	NEXT
	*  
	IF glToolBar
		PutSysVal('TOOLBAR','ON')
	ELSE
		PutSysVal('TOOLBAR','OFF')
	ENDIF
	IF glStatusBar
		PutSysVal('STATUSBAR','ON')
	ELSE
		PutSysVal('STATUSBAR','OFF')
	ENDIF
	*  
	RELEASE goToolBar,goMsgBox
	*   
	SQLdisconnect(gnConnect)
	CLOSE DATA
	*   
	_SCREEN.Icon=''
	_SCREEN.Caption='Microsoft Visual Foxpro 6'
	SET SYSMENU TO DEFAULT
	SET CLASSLIB TO
	ON SHUTDOWN
	ShowSysTBR()
	CLEAR ALL
	* 
	CLEAR EVENTS
	CANCEL
	*QUIT
	RETURN
ENDPROC

***************************************
*	CreateSysFile
*	   
***************************************
PROCEDURE CreateSysFile
	IF NOT FILE('System.cfg')
		LOCAL lnArea
		lnArea=SELECT()
		SELECT 0
		CREATE TABLE System.cfg ;
			(ValName C(20),;
			Value C(60))
		USE
		SELECT (lnArea)
	ENDIF
ENDPROC

***************************************
*	GetSysVal
*	   
***************************************
**	PARAMETERS:
**		1.   (Ch)
****************************************
**	RETURN Ch
****************************************
FUNCTION GetSysVal
PARAMETERS tcVal
	tcVal=UPPER(tcVal)
	LOCAL lnArea
	lnArea=SELECT()
	
	CreateSysFile()
	USE System.cfg IN 0 ALIAS _USF
	SELECT _USF
	LOCATE FOR ALLTRIM(ValName)==tcVal
	IF FOUND()
		tcVal=ALLTRIM(Value)
	ELSE
		tcVal=''
	ENDIF
	USE
	SELECT (lnArea)
	RETURN tcVal
ENDFUNC

***************************************
*	PutSysVal
*	   
***************************************
**	PARAMETERS:
**		1.   (Ch)
**		2.  (Ch)
****************************************
PROCEDURE PutSysVal
PARAMETERS tcVal,tcValue
	tcVal=UPPER(tcVal)
	LOCAL lnArea
	lnArea=SELECT()
	CreateSysFile()
	
	USE System.cfg IN 0 ALIAS _USF
	SELECT _USF
	LOCATE FOR ALLTRIM(ValName)==tcVal
	IF NOT FOUND()
		APPEND BLANK
		REPLACE ValName WITH tcVal,Value WITH tcValue
	ELSE
		REPLACE Value WITH tcValue
	ENDIF
	USE
	SELECT (lnArea)
ENDFUNC
***************************************
*	CursorName
*	   
***************************************
**	RETURN Ch
****************************************
FUNCTION CursorName
LOCAL lcName
lcName=SYS(2015)
DO WHILE USED(lcName)
	lcName=SYS(2015)
ENDDO
RETURN lcName

***************************************
***************************************
* -     
***************************************
DEFINE CLASS cstMsgBox AS Custom
	cTitle=' '
	*  
	PROCEDURE IBox
	LPARAMETER tcMsg
		MESSAGEBOX(tcMsg,64,THIS.cTitle)
	ENDPROC
	*  
	FUNCTION QBox
	LPARAMETER tcMsg
		IF MESSAGEBOX(tcMsg,4+32,THIS.cTitle)=6
			RETURN YES
		ELSE
			RETURN NO
		ENDIF
	ENDFUNC
	*  -
	PROCEDURE SBox
	LPARAMETER tcMsg
		MESSAGEBOX(tcMsg,16,THIS.cTitle)
	ENDPROC
	*  
	PROCEDURE EBox
	LPARAMETER tcMsg
		MESSAGEBOX(tcMsg,48,THIS.cTitle)
	ENDPROC
ENDDEFINE

***************************************
*    
* .  
* ,    .
***************************************
DEFINE CLASS cstIConfig AS Custom
	*   
	lAllDisabled=NO
	*    
	*    
	FUNCTION EnbAction
	LPARAMETER tnAction
		IF TYPE('_SCREEN.ActiveForm')<>'O' OR THIS.lAllDisabled 
			RETURN NO
		ELSE
			RETURN _SCREEN.ActiveForm.FA_Enabled(tnAction)
		ENDIF
	ENDFUNC
	*   ,   
	PROCEDURE DoAction
	LPARAMETER tnAction
		IF THIS.EnbAction(tnAction)
			_SCREEN.ActiveForm.FormAction(tnAction)
		ENDIF
	ENDPROC
ENDDEFINE

****************************************
*      LIFO
****************************************
DEFINE CLASS cstStack AS Custom
	*   
	lEmpty=YES
	*  
	nStackCount=0
	*    
	DIMENSION aStack(1)
	aStack(1)=.NULL.
	*     
	PROCEDURE Push
	LPARAMETER tuVar
		THIS.nStackCount=THIS.nStackCount+1
		IF THIS.lEmpty
			THIS.lEmpty=NO
			THIS.aStack(1)=tuVar
		ELSE
			DIMENSION THIS.aStack(THIS.nStackCount)
			THIS.aStack(THIS.nStackCount)=tuVar
		ENDIF
	ENDPROC
	*     
	FUNCTION Pop
		IF THIS.lEmpty
			RETURN .NULL.
		ENDIF
		LOCAL luVar
		luVar=THIS.aStack(THIS.nStackCount)
		THIS.nStackCount=THIS.nStackCount-1
		THIS.lEmpty=IIF(THIS.nStackCount=0,YES,NO)
		IF THIS.lEmpty
			DIMENSION THIS.aStack(1)
			THIS.aStack(1)=.NULL.
		ELSE
			DIMENSION THIS.aStack(THIS.nStackCount)
		ENDIF
		RETURN luVar
	ENDFUNC
	*   
	PROCEDURE Clear
		DIMENSION THIS.aStack(1)
		THIS.aStack(1)=.NULL.
		THIS.lEmpty=YES
	ENDPROC
ENDDEFINE

